#include <QApplication>
#include <QFile>
#include <QDebug>

#include "manxml.h"

int main()
{

    QDomDocument doc("tom_doc");
    QFile file("./tom.xml");

    if ( (file.open(QIODevice::ReadOnly)) && !(doc.setContent(&file)) ) {
       file.close();
    }
    else
       file.close();

    ManXml manXml;

    QList<Tom> tomGroup;
    Tom tom;
    tomGroup = manXml.parseXMLwithDOM(doc);
    tom = tomGroup.first();

    QList<TomTaskGroup> list = tom.tomTaskGroups;

    QList<TomTaskGroup>::iterator iter;
    for (iter = list.begin(); iter != list.end(); ++iter)
        qDebug() << iter->getName();

    if(manXml.saveXml(tomGroup, "test.xml"))
	qDebug() << "Saved!";

    return 0;
}

