#include <QDebug>
#include <QFile>
//#include <KDesktopFile>
//#include <kdesktopfile.h>

#include "manxml.h"

ManXml::ManXml(){
}

ManXml::~ManXml(){
}

QList<Tom> ManXml::parseXMLwithDOM( QDomDocument &d ){

    Tom m_tom;

    QDomElement tom = d.namedItem("tom").toElement();

    QDomNode tg = tom.firstChild(); 
    for ( ; !tg.isNull(); tg = tg.nextSibling() ) {
    	if ( tg.isElement() && tg.toElement().tagName() == "task_group" ) {

		TomTaskGroup* tomTaskGroup = new TomTaskGroup();
    		QDomElement tg_e = tg.toElement();
		QDomElement task_group_name = tg_e.namedItem("name").toElement();
    		qDebug() << "Task_group name: " + task_group_name.text() + "\n";
		tomTaskGroup->setName(task_group_name.text());

		QDomNode task_ac = tg_e.firstChild();
    		for ( ; !task_ac.isNull(); task_ac = task_ac.nextSibling() ) {
    			if ( task_ac.isElement() && task_ac.toElement().tagName() == "task_action" ) {

				TomTaskAction* tomTaskAction = new TomTaskAction();
    				QDomElement task_ac_e = task_ac.toElement();
				QDomElement task_ac_name = task_ac_e.namedItem("name").toElement();
    				qDebug() << "Task_action name: " + task_ac_name.text() + "\n";
				tomTaskAction->setName(task_ac_name.text());

				QDomNode item = task_ac_e.firstChild();
    				for ( ; !item.isNull(); item = item.nextSibling() ) {
    					if ( item.isElement() && item.toElement().tagName() == "item" ) {


						TomItem* tomItem = new TomItem();
    						QDomElement item_e = item.toElement();

						QDomElement desktop_file = item_e.namedItem("desktop_file").toElement();
    						qDebug() << "Desktop file: " + desktop_file.text() + "\n";
						//KDesktopFile *desktop = new KDesktopFile ( desktop_file.text() );
						tomItem->setDeskFilePath(desktop_file.text());

						QDomElement item_prog = item_e.namedItem("program").toElement();
    						qDebug() << "Item Program: " + item_prog.text() + "\n";
						tomItem->setProgram(item_prog.text());

						QDomElement item_name = item_e.namedItem("name").toElement();
    						qDebug() << "Item Name: " + item_name.text() + "\n";
						tomItem->setName(item_name.text());

						QDomElement item_desc = item_e.namedItem("desc").toElement();
    						qDebug() << "Item Desc: " + item_desc.text() + "\n";
						tomItem->setDesc(item_desc.text());

						tomTaskAction->tomItems.append(*tomItem);
					}
    				}

				tomTaskGroup->tomTaskActions.append(*tomTaskAction);
			}
    		}
		m_tom.tomTaskGroups.append(*tomTaskGroup);
	}
    }

    QList<Tom> tomGroup;
    tomGroup.append(m_tom);
    return tomGroup;
}

bool ManXml::saveXml( QList<Tom> tomGroup, QString fname){

   QDomDocument doc( "xml" );
   QDomElement root = doc.createElement( "tom" );
   doc.appendChild( root );

   QDomText nodeText;

   Tom tom;
   tom = tomGroup.first();

   QList<TomTaskGroup> tg_list = tom.tomTaskGroups;
   QList<TomTaskGroup>::iterator tg_iter;
   for (tg_iter = tg_list.begin(); tg_iter != tg_list.end(); ++tg_iter){

      QDomElement tg = doc.createElement( "task_group" );
      QDomElement tg_name = doc.createElement( "name" );
      QDomElement tg_name_lc = doc.createElement( "locale" );

      tg_name_lc.setAttribute( "type", "en" );

      nodeText = doc.createTextNode(tg_iter->getName());
      tg_name_lc.appendChild(nodeText);
      tg_name.appendChild(tg_name_lc);
      tg.appendChild(tg_name);

      QList<TomTaskAction> ta_list = tg_iter->tomTaskActions;
      QList<TomTaskAction>::iterator ta_iter;
      for (ta_iter = ta_list.begin(); ta_iter != ta_list.end(); ++ta_iter){

	      QDomElement ta = doc.createElement( "task_action" );
	      QDomElement ta_name = doc.createElement( "name" );
	      QDomElement ta_name_lc = doc.createElement( "locale" );

	      ta_name_lc.setAttribute( "type", "en" );

	      nodeText = doc.createTextNode(ta_iter->getName());
	      ta_name_lc.appendChild(nodeText);
	      ta_name.appendChild(ta_name_lc);
	      ta.appendChild(ta_name);

	      QList<TomItem> itm_list = ta_iter->tomItems;
	      QList<TomItem>::iterator itm_iter;
	      for (itm_iter = itm_list.begin(); itm_iter != itm_list.end(); ++itm_iter){

		      QDomElement itm = doc.createElement( "item" );
		      QDomElement item_desk = doc.createElement( "desktop_file" );

		      nodeText = doc.createTextNode(itm_iter->getDeskFilePath());
		      item_desk.appendChild(nodeText);
		      itm.appendChild(item_desk);
		      ta.appendChild(itm);
	     }
	     tg.appendChild(ta);
      }

      root.appendChild( tg );
   }

   QFile file( fname );
   if( !file.open( QIODevice::WriteOnly ) )
   	return false;

   QTextStream ts( &file );
   ts << doc.toString();

   file.close();

   return true;
}

